open Syntax
open Expression
open Expression.Types
open Expression.FableType

type uft = FableType.unchecked_fable_type
and tft =  FableType.fable_type
and 'a fq = 'a FableType.fable_qualifier 

val annot : kind -> Types.ldatatype -> Types.datatype
val unlabel_type : Types.assumption
val relabel_type : Types.assumption

val fresh_label_type : unit -> Types.datatype
val fresh_kind_variable : kind -> 'a kind_var_basis Unionfind.point

val sub_kind : (FableType.kind * FableType.kind) -> bool
val sub_kind_fq : ('a fq * 'a fq) -> bool 

val get_label_type_expr : 'a fq -> 'a expression' option

val get_name_bindings : 'a fq -> (string list * string option)
val strip_name_bindings : 'a fq -> 'a fq
val strip_name_bindings_type : datatype -> datatype
val restore_bindings : string list -> string option -> datatype -> datatype
val add_phantom_bindings : string list -> Typeenv.omega -> Typeenv.omega
  
val free_names : ?expect_empty:bool -> Typeenv.omega -> 'a datatype' -> string list

val is_empty : 'a fq  -> bool
val as_string : fable_type -> string
val kind_qual : fable_type -> kind

val row_labels_inorder : ?filter_absent:bool -> 'a field_spec_map' -> (string * 'a field_spec') list 
  
(* (\* type fable_env *\) *)
(* (\* val initial_fable_env : fable_env *\) *)

(* val type_program : Types.typing_environment -> Syntax.program -> Syntax.program *)
(* (\* val check_expression : Types.typing_environment -> Syntax.expression -> Syntax.expression *\) *)
