module type S =
  sig
    module Query : Mkquery.Q

    (* Translate a query into a valid SQL string *)
    val string_of_query : Query.query -> string
      
    (* Below only used by Sql_transform *)
    val conjunction : Query.expression list -> Query.expression
    val disjunction : Query.expression list -> Query.expression
    val negation : Query.expression -> Query.expression
    val simplify : Query.expression -> Query.expression
  end

module Make (Q : Mkquery.Q) : S with module Query = Q
