open Syntax
open Expression

exception Subst of string 

type subst

val empty : subst
val extend : (string * expression) -> subst -> subst
val union : subst -> subst -> subst
val restrict : subst -> string list -> subst
val domain : subst -> string list
val apply_e : subst -> expression -> expression
val apply_fq : subst -> FableType.fable_type -> FableType.fable_type
val apply : subst -> Types.datatype -> Types.datatype

val rename_bound_vars : Types.datatype -> Types.datatype
