(** Converts the tree returned by the parser into our internal
    representation *)
exception ConcreteSyntaxError of (string * (Lexing.position * Lexing.position))
exception PatternDuplicateNameError of (Expression.position * string * string)
exception RedundantPatternMatch of Expression.position

val normalize_type : Expression.Types.u_datatype -> Expression.Types.datatype
val desugar_expression : (Sugartypes.pposition -> Expression.position) -> Sugartypes.phrase -> Syntax.untyped_expression
val desugar_definitions : (Sugartypes.pposition -> Expression.position) -> Sugartypes.phrase list -> Syntax.untyped_definition list
val desugar_datatype : (Sugartypes.pposition -> Expression.position) -> Sugartypes.datatype -> Expression.Types.u_assumption
val fresh_type_variable : unit -> Sugartypes.datatype
